#! /usr/local/bin/python -O


import sys
from socket import *


PORT = 8888
BUFSIZE = 1024

def main():
   # get port
   if len(sys.argv) > 1:
      port = int(eval(sys.argv[1]))
   else:
      port = PORT

   # make socket
   s = socket(AF_INET, SOCK_STREAM)
   s.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
   s.bind(('', port))
   s.listen(1)

   print "Waiting..."
   conn = None

   try:
      # wait
      conn, (remotehost, remoteport) = s.accept()
      instream = conn.makefile('r', BUFSIZE)

      # connected
      print 'Connected by', remotehost, remoteport

      # get data
      request = ''

      while 1:
         line = instream.readline()
         if line in (None, "\n", "\r\n"):
            break
         request = request + line

      # store to file
      outfile = open("request.txt", 'w')
      outfile.write(request)
      outfile.close()

      conn.send("""\
HTTP/1.1 200 Ok
Content-Type: text/plain
Connection: close

Your request has been logged. Thank you. Goodbye.
""")

   finally:
      if conn:
         instream.close()
         conn.close()
      s.close()

   print "Done."

main()
